<template>
  <div class="ob-spot">
    <div class="ob-spot__content">
      <div class="ob-spot__content_left">
        <div class="ob-content__header">
          <div class="ob-spot-info">
            <router-link
                class="icon chevron-left"
                :to="{ path: '/spot-list-draft' }"
            />
            <h1 class="title">Заказ на проведение аукциона {{ spotNumber }}</h1>
            <span class="ref">Черновик</span>
          </div>
        </div>
        <div class="ob-content__body">
          <div class="ob-spot-box">
            <div class="ob-spot-box__header route">
              <div class="ob-spot-box__title">Маршрут<i class="icon checked" :class="routeClassStyle"></i></div>
              <div class="ob-spot-box__way" v-if="isRoute">{{ routeLengthInKm }}&nbsp;км,
                ≈&nbsp;{{ routeDurationInHr }}&nbsp;ч в&nbsp;движении
              </div>
              <div class="ob-spot-box__map disable"><i class="icon map"></i>Посмотреть на карте</div>
            </div>

            <div class="ob-spot__subbox">
              <template v-for="(item, index) in loadedPoints">
                <SpotDraftPoint
                    :title-info="mapInfo.loaded"
                    :id-elem="index"
                    :key="`loaded + ${index}`"
                    :point-info="item"
                    @change="changeLoadedPoint(index, $event)"
                    @remove="removeLoadedPoint(index)"
                />
              </template>

              <div class="ob-spot__row">
                <div class="ob-spot__add"
                     :class="{disabled: isEmptyLoadedPoints}"
                     @click="addLoadedPoint(loadedPoints.length)">
                  <i class="icon plus"></i>Добавить погрузку
                </div>
              </div>
            </div>

            <div class="ob-spot__subbox">
              <template v-for="(item, index) in unloadedPoints">
                <SpotDraftPoint
                    :title-info="mapInfo.unloaded"
                    :id-elem="index"
                    :key="`unloaded + ${index}`"
                    :point-info="item"
                    @change="changeUnloadedPoint(index, $event)"
                    @remove="removeUnloadedPoint(index)"
                />
              </template>

              <div class="ob-spot__row">
                <div class="ob-spot__add"
                     :class="{disabled: isEmptyUnloadedPoints}"
                     @click="addUnLoadedPoint(unloadedPoints.length)">
                  <i class="icon plus"></i>Добавить разгрузку
                </div>
              </div>
            </div>
          </div>

          <div class="ob-spot-box">
            <div class="ob-spot-box__header">
              <div class="ob-spot-box__title">Груз</div>
            </div>
            <div class="ob-spot__subbox">
              <div class="ob-spot__row">
                <div class="ob-spot__col-2-1">
                  <ob-select
                      label="Тип груза (необязательно)"
                      placeholder="Выберите из списка"
                      displayExp="name"
                      valueExp="uuid"
                      v-model="cargoTypeValues"
                      data-qa="multiselectCargoType"
                      :items="cargoTypes"
                      :is-multiselect="true"
                      :is-dropdown="true"
                      :is-tagbox="true"
                      @input="onSelectCargoTypeValue"
                  />
                </div>
                <div class="ob-spot__col-2-2">
                  <ob-input
                      v-model.number="cargoWaybillPrice"
                      type="money"
                      :isTrimOnBlur="false"
                      subTitle="₽"
                      label="Стоимость по накладной"
                      placeholder="Укажите стоимость"
                      data-qa="inputCargoWaybillPrice"
                      @input="onChangeWaybillPrice"
                  />
                </div>
              </div>
            </div>
          </div>

          <div class="ob-spot-box">
            <div class="ob-spot-box__header">
              <div class="ob-spot-box__title">Способ перевозки<i class="icon checked"
                                                                 :class="transportationClassStyle"></i></div>
            </div>
            <div class="ob-spot__subbox">
              <div class="ob-spot__row">
                <div class="ob-spot__col-3-1">
                  <ob-select
                      label="Вид автотранспорта"
                      :value="resourceSpeciesUuid"
                      :items="transportViews"
                      :required="true"
                      placeholder="Выберите из списка"
                      data-qa="selectTransportView"
                      @input="onChangeTransportViews"
                  />
                </div>
                <div class="ob-spot__col-3-2">
                  <ob-select
                      v-model="resourceTypeUuid"
                      label="Тип автотранспорта"
                      :required="true"
                      :disabled="!transportTypes.length"
                      placeholder="Выберите из списка"
                      :items="transportTypes"
                      data-qa="selectTransportType"
                      @input="onChangeTransportType"
                  />
                </div>
                <div class="ob-spot__col-3-3">
                  <ob-stepper
                      label="Кол-во (шт)"
                      :disabled="true"
                      :step="1"
                      :allowNegatives="false"
                      v-model.number="numberOfVehicle"
                      data-qa="stepperNumberOfVehicle"
                      @input="onChangeNumOfVehicle"
                  />
                </div>
              </div>
              <div class="ob-spot__row">
                <div class="ob-spot__col-3-1">
                  <div class="ob-spot__row __center">
                    <div class="ob-spot__col-3-1-1">
                      <div class="ob-spot-box__tracking">
                        <i class="icon radar"></i>
                        <ob-checkbox
                            label="Трекинг груза"
                            v-model="needTracking"
                            data-qa="checkboxNeedTracking"
                            @change="onCheckNeedTracking"
                        />
                      </div>
                    </div>
                    <div class="ob-spot__col-3-1-2">
                      <ob-select
                          v-model="dangerousClassUuid"
                          :items="cargoDangerClasses"
                          :required="false"
                          label="Класс опасности груза"
                          placeholder="Выберите из списка"
                          :labelInfo="'Класс опасности груза'"
                          data-qa="cargoDangerClass"
                          @input="onChangeDangerClass"
                      />
                    </div>
                    <div class="ob-spot__col-3-1-3">
                      <ob-select
                          v-model="temperatureModeUuid"
                          label="Температурный режим"
                          placeholder="Выберите из списка"
                          :labelInfo="'Температурный режим'"
                          :items="temperatureModes"
                          data-qa="selectTemperatureMode"
                          displayExp="temperatureModeTitle"
                          valueExp="temperatureModeUuid"
                          @input="onChangeTemperatureMode"
                      />
                    </div>
                  </div>
                </div>
                <div class="ob-spot__col-3-3"></div>
              </div>
            </div>
          </div>

          <div class="ob-spot-box">
            <div class="ob-spot-box__header">
              <div class="ob-spot-box__title">Дополнительные требования и комментарий</div>
            </div>
            <div class="ob-spot__subbox">
              <div class="ob-spot__row">
                <div class="ob-spot__col-1">
                  <ob-select
                      label="Дополнительные требования к сервису и безопасности (необязательно)"
                      placeholder="Выберите из списка"
                      displayExp="title"
                      valueExp="uuid"
                      v-model="serviceRequirements"
                      data-qa="selectServiceRequirements"
                      :items="securityItems"
                      :required="false"
                      :is-multiselect="true"
                      :is-dropdown="true"
                      :is-tagbox="true"
                      @input="onChangeServiceRequirements"
                  />
                </div>
              </div>
              <div class="ob-spot__row">
                <div class="ob-spot__col-1">
                  <ob-textarea
                      label="Комментарий для исполнителя (необязательно)"
                      placeholder="Введите текст"
                      data-qa="textareaComment"
                      :value="comment"
                      @input="onChangeComment"
                  />
                </div>
              </div>
              <div class="ob-spot__row">
                <div class="ob-spot__col-1">
                  <ob-input
                      :value="externalNumber"
                      label="Внутренний номер заказа клиента"
                      placeholder="Введите текст"
                      data-qa="inputExternalNumber"
                      @input="onChangeExternalNumber"
                  />
                </div>
              </div>
            </div>
          </div>

          <div class="ob-collapse">
            <div class="ob-collapse__item" :class="{'ob-collapse__active': isCollapseOpened}">
              <div class="ob-collapse__header" @click="toggleCollapse">
                <i class="icon chevron-right"></i>Прикрепить файлы
                <div class="ob-collapse__header-slot" v-if="!!filesCount"><i class="icon attach"></i>{{ filesCount }}
                </div>
              </div>
              <expand-transition scrollIntoView>
                <div class="ob-collapse__body" v-show="isCollapseOpened">

                  <p class="ob-spot__text">Вы можете прикрепить дополнительные файлы. Их увидят исполнители</p>
                  <ObUploader
                      icon="excel"
                      :multiple="true"
                      :isDetailEmit="true"
                      :value="currentFiles"
                      data-qa="fileUploader"
                      @change="onChangeFiles($event)"
                  />
                </div>
              </expand-transition>
            </div>
          </div>
        </div>
      </div>
      <div class="ob-spot__content_right">
        <SpotDraftItemSettings
          v-if="isReady"
          :settings="auctionSettings"
          :loading-at="loadingAt"
          :is-copy-item="isCopyItem"
          :block-button="blockButton"
          @change="onChangeSettings"
        />
        <ObLoader v-else />
      </div>
    </div>
  </div>
</template>

<script>
import api from '@/api'
import { uuid } from 'vue-uuid'
import { mapGetters, mapMutations, mapActions } from 'vuex'
import { getTokenData } from '@/tokenData'
import { spotInitItem } from '@/resources/spot'
import debounce from 'debounce'
import { LOADED_STATE } from '@/resources/enum'

import SpotDraftItemSettings from './spotDraftItemSettings'
import SpotDraftPoint from './spotDraftPoint'
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import obStepper from "common-components/src/obComponents/obStepper"
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'
import expandTransition from '../../../components/ExpandTransition'
import ObLoader from 'common-components/src/obComponents/obLoader'

const initPoint = {
  ordinal: 1,
  addressCoordinates: {},
  addressTitle: '',
  locationUuid: ''
}

export default {
  name: 'spotDraftItem',
  components: {
    SpotDraftItemSettings,
    SpotDraftPoint,
    ObInput,
    ObSelect,
    obStepper,
    ObCheckbox,
    ObTextarea,
    ObUploader,
    ObLoader,
    expandTransition
  },
  data () {
    return {
      loadedPoints: [{
        pointType: 'LOADING',
        pointUuid: uuid.v4(),
        arrivalDt: this.getNextDate(new Date()),
        ...initPoint
      }],
      unloadedPoints: [{
        pointType: 'UNLOADING',
        pointUuid: uuid.v4(),
        arrivalDt: this.getNextDate(new Date()),
        ...initPoint
      }],
      mapInfo: {
        loaded: {
          label: 'Погрузка',
          color: 'orange',
          key: 'loaded'
        },
        unloaded: {
          label: 'Разгрузка',
          color: 'green',
          key: 'unloaded'
        }
      },
      transportViews: [],
      points: [],
      countTransport: 1,
      costBill: null,
      cargoTypes: [],
      securityItems: [],
      securityValues: [],
      transportTypes: [],
      temperatureModes: [],
      cargoDangerClasses: [],
      isCollapseOpened: true,

      files: [],
      filesData: [],

      main: {},

      dangerousClassUuid: '',
      resourceSpeciesUuid: '',
      resourceTypeUuid: '',
      numberOfVehicle: 1,
      needTracking: false,
      temperatureModeUuid: '',

      cargoTypeValues: [],
      cargoWaybillPrice: '',

      serviceRequirements: [],
      comment: '',
      externalNumber: '',

      routeLengthInKm: 0,
      routeDurationInHr: 0,

      isCopyItem: false,
      blockButton: false
    }
  },
  computed: {
    ...mapGetters({
      spotItem: 'spot/spotItem',
      spotNumber: 'spot/spotNumber',
      loadedState: 'spot/loadedState'
    }),
    isReady () {
      return this.loadedState === LOADED_STATE.READY
    },
    isEmptyLoadedPoints () {
      return this.checkEmptyPointList(this.loadedPoints)
    },
    isEmptyUnloadedPoints () {
      return this.checkEmptyPointList(this.unloadedPoints)
    },
    isRoute () {
      return this.routeDurationInHr && this.routeLengthInKm // estimatedTime, pathLength
    },
    isTransportationMethod () {
      return this.resourceSpeciesUuid && (this.resourceTypeUuid || !this.transportTypes.length)
    },
    isFilledRoute () {
      return this.loadedPoints.every(item => item.addressTitle && item.arrivalDt) &&
          this.unloadedPoints.every(item => item.addressTitle && item.arrivalDt)
    },
    routeClassStyle () {
      return this.isFilledRoute ? 'green' : 'grey'
    },
    transportationClassStyle () {
      return this.isTransportationMethod ? 'green' : 'grey'
    },
    localePoints () {
      const fullLoadedPoints = this.loadedPoints.filter(point => !!point.addressTitle)
      const fullUnloadedPoints = this.unloadedPoints.filter(point => !!point.addressTitle)
      return [...fullLoadedPoints, ...fullUnloadedPoints]
    },
    loadingAt () {
      return this.loadedPoints.find(point => point.ordinal === 1).arrivalDt
    },
    auctionSettings () {
      return this.isCopyItem ? { ...this.spotItem.auction, duration: 1 } : {...this.spotItem.auction}
    },
    currentFiles () {
      return this.filesData
    },
    filesCount () {
      return this.files?.length
    }
  },
  beforeCreate () {
    if (this.$route.params.id === 'spot-new') {
      this.$router.push({ name: 'spot__draft__item__final', params: { uuid: uuid.v4(), id: 'created' } }).catch(() => {});
    }
  },
  async created () {
    const vm = this;
    window.onpopstate = function() {
      vm.$router.push({path: '/spot-list'});
    };
    this.setSpotState(LOADED_STATE.LOADING)

    await this.setMainContractor()

    api.cargo
       .getOrderCargoTypes(0, 100)
       .then(res => {
         this.cargoTypes = res.data.content.filter(item => item.is_active);
       })
       .catch(e => {
         console.error(e);
         this.$notification({
           type: "system_notification_error",
           message: "Ошибка загрузки данных"
         });
       })

    api.services
       .getActiveServiceRequirements()
       .then(res => {
         this.securityItems = res.filter(item => item.isActive)
       })
       .catch(e => {
         console.error(e);
         this.$notification({
           type: "system_notification_error",
           message: "Ошибка загрузки данных"
         });
       })

    api.dictionaries.temperature
       .getTempConditionsV2()
       .then(res => {
         this.temperatureModes = res
       })
       .catch(e => {
         console.error(e);
         this.$notification({
           type: "system_notification_error",
           message: "Ошибка загрузки данных"
         });
       })

    api.dictionaries.resources
       .getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
       .then(async res => {
         this.transportViews = res
         this.resourceSpeciesUuid = res.find(item => item.title === 'Полуприцеп').uuid
         await this.getResourceTypes(this.resourceSpeciesUuid)
       })
       .catch(e => {
         console.error(e);
         this.$notification({
           type: "system_notification_error",
           message: "Ошибка загрузки данных"
         });
       })

    await this.installItem()
  },
  watch: {
    'resourceSpeciesUuid' () {
      this.setSpotItem({
        transportation: {
          ...this.spotItem.transportation,
          resourceSpeciesUuid: this.resourceSpeciesUuid
        }
      })
    }
  },
  methods: {
    ...mapMutations({
      setSpotItem: 'spot/SET_SPOT_ITEM',
      setSpotState: 'spot/SET_SPOT_STATE',
      setSpotNumber: 'spot/SET_SPOT_NUMBER',
      setSpotError: 'spot/SET_SPOT_ERRORS'
    }),
    ...mapActions({
      getSpotItem: 'spot/getSpotItem',
      validationSpotDraft: 'spot/validationSpotDraft'
    }),

    async setMainContractor () {
      const number = await api.spotAuction
                              .getSpotId()
                              .then((res) => {
                                return res.data
                              })
      this.setSpotNumber(number.code)

      const contractor = getTokenData()
      this.main = {
        contractor: {
          roleCode: contractor.contractor_role_code.toUpperCase(),
          uuid: contractor.contractor_uuid,
          title: contractor.preferred_username
        },
        number: this.spotNumber
      }
    },

    async installItem () {
      // id = 'created' - идентификатор создания новой страницы
      if (this.$route.params.id === 'created' && !this.$route.params.rowUuid) {

        /*
         * Зашита первая ошибка при создании черновика,
         * т.к. сохранение черновика возможно только при заполнении первой точки,
         * а валидация происходит по сохраненному uuid заказа
        */
        this.setSpotError([{
          code: 'DEPARTURE_POINT_LOCATION_NOT_FOUND',
          description: 'Не найден опорник для точки погрузки'
        }])

        this.setSpotItem({ ...spotInitItem, main: this.main, points: this.localePoints })
        this.setSpotState(LOADED_STATE.READY)
      } else {
        try {
          // const uuidMock = '8b8f7dd7-917b-4012-91c4-0b03f1d4bda4'
          if (this.$route.params.rowUuid) {
            this.isCopyItem = true
            await api.spotAuction.copySpotItem(this.$route.params.rowUuid, this.$route.params.uuid)
          }
          await this.getSpotItem({uuid:this.$route.params.uuid, isCopy: this.isCopyItem}) // достаем СПОТ данные по id
          const loadedPointsLocal = this.spotItem.points
                                        .filter(point => point.pointType === 'LOADING')
                                        .sort((a, b) => {
                                          return a.ordinal - b.ordinal
                                        })
          const unloadedPointsLocal = this.spotItem.points
                                          .filter(point => point.pointType === 'UNLOADING')
                                          .sort((a, b) => {
                                            return a.ordinal - b.ordinal
                                          })

          if (loadedPointsLocal.length) {
            this.loadedPoints = loadedPointsLocal
          }

          if (unloadedPointsLocal.length) {
            this.unloadedPoints = unloadedPointsLocal
          }

          this.number = this.spotItem.main.number

          this.cargoWaybillPrice = this.spotItem.cargo.cargoWaybillPrice
          this.cargoTypeValues = [...this.spotItem.cargo.cargoTypes]

          this.serviceRequirements = this.spotItem.parameters.serviceRequirements ? [...this.spotItem.parameters.serviceRequirements] : []
          this.comment = this.spotItem.parameters.comment
          this.externalNumber = this.spotItem.main.externalNumber

          this.routeLengthInKm = this.spotItem.main.routeLengthInKm
          this.routeDurationInHr = this.spotItem.main.routeDurationInHr

          this.resourceTypeUuid = this.spotItem.transportation.resourceTypeUuid
          this.numberOfVehicle = this.spotItem.transportation.numberOfVehicle
          this.needTracking = this.spotItem.transportation.needTracking

          this.dangerousClassUuid = this.spotItem.transportation.dangerousClassUuid
          this.temperatureModeUuid = this.spotItem.transportation.temperatureModeUuid
          if (this.spotItem.transportation.resourceSpeciesUuid) {
            this.resourceSpeciesUuid = this.spotItem.transportation.resourceSpeciesUuid
          } else {
            this.resourceSpeciesUuid = this.transportViews.find(item => item.title === 'Полуприцеп').uuid
          }
          this.filesData = this.spotItem.parameters.files?.map(({ fileName, fileUuid }) => {
            return {
              uuid: fileUuid,
              file: {
                name: fileName
              },
              isUploaded: true
            }
          }) || []

          this.files = this.spotItem.parameters.files?.map((file) => {
            return {
              fileUuid: file.fileUuid
            }
          }) || []

          await this.getResourceTypes(this.resourceSpeciesUuid)
          await this.validationSpotDraft(this.$route.params.uuid)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
    },

    checkEmptyPointList (points) {
      return points.some((point) => point.addressTitle === '')
    },

    addLoadedPoint () {
      let _d = this.loadedPoints.length ? this.loadedPoints[this.loadedPoints.length - 1].arrivalDt : new Date()
      let order = this.loadedPoints.length ? this.loadedPoints[this.loadedPoints.length - 1].ordinal : 0
      this.loadedPoints.push({
        pointType: 'LOADING',
        ordinal: order + 1,
        pointUuid: uuid.v4(),
        arrivalDt: _d,
        addressCoordinates: {},
        addressTitle: '',
        locationUuid: ''
      })
      this.updatePoints()
    },

    addUnLoadedPoint () {
      let _d = this.unloadedPoints.length ? this.unloadedPoints[this.unloadedPoints.length - 1].arrivalDt : new Date()
      let order = this.unloadedPoints.length ? this.unloadedPoints[this.unloadedPoints.length - 1].ordinal : 0
      this.unloadedPoints.push({
        pointType: 'UNLOADING',
        ordinal: order + 1,
        pointUuid: uuid.v4(),
        arrivalDt: _d,
        addressCoordinates: {},
        addressTitle: '',
        locationUuid: ''
      })
      this.updatePoints()
    },

    async changeLoadedPoint (index, data) {
      this.loadedPoints.splice(index, 1, data)
      await this.checkRoute()
      this.updatePoints()
    },

    async changeUnloadedPoint (index, data) {
      this.unloadedPoints.splice(index, 1, data)
      await this.checkRoute()
      this.updatePoints()
    },

    removeLoadedPoint (index) {
      this.loadedPoints.splice(index, 1)
      this.updatePoints()
    },

    removeUnloadedPoint (id) {
      this.unloadedPoints.splice(id, 1)
      this.updatePoints()
    },

    async checkRoute () {
      const startPoint = this.loadedPoints[0].addressCoordinates
      const endPoint = this.unloadedPoints[0].addressCoordinates
      if (startPoint && startPoint.hasOwnProperty('lat') && endPoint && endPoint.hasOwnProperty('lat')) {
        const route = [
          [startPoint.lat, startPoint.lon],
          [endPoint.lat, endPoint.lon]
        ]
        const res = await api.geocoder.getRoute(route)
        if (res && res.data) {
          this.routeDurationInHr = Math.ceil(res.data.properties.estimated_time / 60)
          this.routeLengthInKm = Math.floor(res.data.properties.path_lenght / 1000)
        }
      }
    },

    onChangeWaybillPrice: debounce(function (e) {
      this.cargoWaybillPrice = e
      this.updateCargo()
    }, 1000),

    onSelectCargoTypeValue (e) {
      this.cargoTypeValues = e
      this.updateCargo()
    },

    updateMain () {
      const main = {
        ...this.spotItem.main,
        routeDurationInHr: this.routeDurationInHr,
        routeLengthInKm: this.routeLengthInKm,
        externalNumber: this.externalNumber
      }
      this.setSpotItem({ main })
      this.saveForm()
    },

    updateCargo () {
      const cargo = {
        cargoWaybillPrice: this.cargoWaybillPrice,
        cargoTypes: this.cargoTypeValues
      }
      this.setSpotItem({ cargo })
      this.saveForm()
    },

    updateParameters () {
      const parameters = {
        serviceRequirements: this.serviceRequirements,
        comment: this.comment,
        files: this.files
      }
      this.setSpotItem({ parameters })
      this.saveForm()
    },

    onChangeServiceRequirements (e) {
      this.serviceRequirements = e
      this.updateParameters()
    },

    onChangeComment: debounce(function (e) {
      this.comment = e
      this.updateParameters()
    }, 2000),

    async onChangeFiles (e) {
      if (e.added) {
        const uploadRequest = ({ uuid, file }) => {
          return new Promise((resolve, reject) => {
            api.files.postFileUpload({ uuid, file })
               .then(() => {
                 resolve()
               })
               .catch(error => {
                 reject(error)
               })
          })
        }

        const uploadFiles = async (array) => {
          const promises = array.map(uploadRequest)
          await Promise.all(promises)
        }

        await uploadFiles(e.added)

        e.added.forEach(file => {
          this.files.push({ fileUuid: file.uuid })
        })
      } else if (e.deleted) {
        try {
          await api.files.deleteFile(e.deleted);
          this.files = this.files.filter(function (file) {
            return file.fileUuid !== e.deleted
          });
        } catch (err) {
          console.error(err)
        }
      }
      this.updateParameters()
    },

    onChangeExternalNumber: debounce(function (e) {
      this.externalNumber = e
      this.updateMain()
    }, 2000),

    onCargoTypeChange (e) {
      this.cargoType = e
    },

    toggleCollapse () {
      this.isCollapseOpened = !this.isCollapseOpened
    },

    updatePoints () {
      this.setSpotItem({ points: this.localePoints })
      this.saveForm()
    },

    async getResourceTypes (uuid) {
      try {
        const types = await api.resources.getResourceTypesDropdownBySpecies(uuid)
        this.transportTypes = types
      } catch (e) {
        console.error(e)
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        })
      }
    },

    onChangeDangerClass (e) {
      this.dangerousClassUuid = e
      this.updateTransportation()
    },

    onChangeTemperatureMode (e) {
      this.temperatureModeUuid = e
      this.updateTransportation()
    },

    async onChangeTransportViews (e) {
      this.resourceSpeciesUuid = e
      this.resourceTypeUuid = ''
      await this.getResourceTypes(e)
      this.updateTransportation()
    },

    onChangeTransportType (e) {
      this.resourceTypeUuid = e
      this.updateTransportation()
    },

    onChangeNumOfVehicle (e) {
      this.numberOfVehicle = e
      this.updateTransportation()
    },

    onCheckNeedTracking (e) {
      this.needTracking = e
      this.updateTransportation()
    },

    updateTransportation () {
      const transportation = {
        resourceClassUuid: 'e7519b46-faf4-11e9-8f0b-362b9e155667',
        numberOfVehicle: this.numberOfVehicle,
        needTracking: this.needTracking,
        dangerousClassUuid: this.dangerousClassUuid,
        resourceSpeciesUuid: this.resourceSpeciesUuid,
        resourceTypeUuid: this.resourceTypeUuid,
        temperatureModeUuid: this.temperatureModeUuid
      }
      this.setSpotItem({ transportation })
      this.saveForm()
    },

    onChangeSettings (auction) {
      this.setSpotItem({ auction })
      this.saveForm()
    },

    async saveForm () {
      this.blockButton = true;
      try {
        await api.spotAuction.saveSpotItemDraft(this.$route.params.uuid, this.spotItem)
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
        await this.validationSpotDraft(this.$route.params.uuid)
      } catch (e) {
        console.error(e)
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      } finally {
        this.blockButton = false;
      }
    },

    getNextDate (date) {
      const _d = new Date(date)
      _d.setDate(_d.getDate() + 1)
      return _d
    }
  }
}
</script>

<style lang="scss" scoped>
@import "node_modules/common-components/src/static/css/variables";
@import "node_modules/common-components/src/static/css/mixins";

@mixin hover-active-disabled($hover, $active, $disabled) {
  &:not(.disabled):hover {
    cursor: pointer;
    color: rgba($hover, 0.8);
  }
  &:active {
    color: $active;
  }
  &.disabled {
    color: $disabled;
    pointer-events: none;
  }
}

.ob-spot {
  margin: 20px;
  background: $background-white;
  color: $color-text-base;
  border-radius: 3px;
  position: relative;
  width: calc(100% - 40px);

  .ob-selector {
    margin-bottom: 0;
  }

  &__content {
    display: flex;
    width: 100%;
    position: relative;

    &_left {
      width: calc(100% - 316px);
      overflow: hidden;
    }

    &_right {
      width: 316px;
      min-height: calc(100vh - 144px);
      box-shadow: 0 0 2px rgba(0, 75, 200, 0.15),
      0 0 12px rgba(0, 75, 200, 0.04),
      0 4px 10px rgba(0, 75, 200, 0.06);
    }

    .ob-content__header {
      width: 100%;
      min-height: 60px;
      padding: 10px 20px;
      background-color: $background-white;
      box-shadow: 0 0 2px rgba(0, 75, 200, 0.15),
      0 0 12px rgba(0, 75, 200, 0.04),
      0 4px 10px rgba(0, 75, 200, 0.06);
    }

    .ob-content__body {
      padding: 20px;
    }
  }

  &__subbox {
    margin-bottom: 30px;
  }

  &__wrap {
    overflow: hidden;
    position: relative;

    &:not(:nth-child(1)) {
      padding: 11px 20px 0;
      margin-right: -20px;
    }

    &:not(:nth-child(1)):hover {
      background-color: $color-white-lilac;
    }

    .icon.close {
      position: absolute;
      right: 23px;
      top: 13px;
      font-size: 10px;
      color: $color-grey-span;

      &:hover {
        color: $color-error;
        cursor: pointer;
      }
    }
  }

  &__row {
    width: 100%;
    display: flex;
    margin: 10px 0 10px;

    &.__center {
      align-items: center;
    }

    [class*="__col"]:not(:last-child) {
      margin-right: 10px;
    }
  }

  &__col {
    &-1 {
      flex-basis: 100%;
    }

    &-2-1 {
      flex-basis: 70%;
      flex-grow: 1;
    }

    &-2-2 {
      position: relative;
      z-index: 1;
      height: 52px;
      flex-grow: 1;
    }

    &-3-1 {
      flex: 1 0 32%;

      &-1 {
        flex-basis: 25%;
        flex-grow: 1;
      }

      &-2 {
        flex-basis: 32%;
        flex-grow: 1;
      }

      &-3 {
        flex-basis: 32%;
        flex-grow: 1;
      }
    }

    &-3-2 {
      flex-basis: 52%;
      flex-grow: 1;
    }

    &-3-3 {
      flex-basis: 160px;
    }
  }

  &__add {
    @include hover-active-disabled($color-blue-navy-blue, #006596, $gray-window);
    color: $color-blue-navy-blue;
    padding-left: 20px;

    .icon {
      font-size: 16px;
      margin-right: 6px;
      vertical-align: -1px;
    }
  }

  &__text {
    color: $gray-slate;
    margin-bottom: 15px;
  }

  &-info {
    display: flex;
    align-items: center;
    margin-bottom: 8px;

    .title {
      display: inline-block;
      font-size: 24px;
      line-height: 36px;
    }

    .icon {
      text-decoration: none;
      color: $color-blue-navy-blue;
      margin-right: 12px;
      font-size: 26px;
    }

    .ref {
      font-size: 10px;
      text-transform: uppercase;
      color: rgba($gray-slate, 0.8);
      align-self: flex-start;
      padding: 5px 0 0 5px;
    }
  }

  &-details {
    display: flex;
    align-items: center;
    padding-bottom: 8px;

    .contractor {
      padding-left: 10px;
      padding-right: 7px;
    }
  }

  &-box {
    &__header {
      display: flex;
      align-items: center;
      margin-bottom: 15px;

      &.route {
        margin-bottom: 21px;
      }
    }

    &__title {
      font-size: 20px;
      line-height: 28px;
      font-weight: bold;
      padding-right: 40px;

      .icon {
        font-size: 16px;
        padding-left: 5px;
      }
    }

    &__way {
      font-size: 12px;
      color: $gray-slate;
      padding-right: 20px;
    }

    &__map {
      @include hover-active-disabled($color-blue-navy-blue, #006596, $gray-window);
      font-size: 12px;
      color: $color-blue-navy-blue;

      .icon {
        font-size: 16px;
        padding-right: 6px;
      }
    }

    &__tracking {
      white-space: nowrap;

      .icon {
        color: $color-blue-navy-blue;
        margin-right: 12px;
      }

      .ob-checkbox-container {
        display: inline-block;
      }
    }
  }

  .icon {
    &.green {
      color: $color-green-light;
    }

    &.grey {
      color: $color-grey-border;
    }

    &.orange {
      color: $diamond-orange-yellow;
    }
  }

  .ob-collapse {
    &__header {
      position: relative;
      display: flex;
      align-items: center;
      height: 40px;
      padding: 0 50px 0 11px;
      background-color: $light-lavender;
      font-size: 16px;
      line-height: 20px;
      font-weight: bold;
      color: $color-blue-navy-blue;
      border-bottom: 1px solid $obInput-border_blue;

      .icon {
        &[class*="chevron"] {
          font-size: 23px;
          margin-right: 10px;
        }
      }

      &-slot {
        position: absolute;
        right: 19px;
        font-size: 14px;
        font-weight: 400;
      }
    }

    &__body {
      margin: 40px 0 10px;
    }

    &__active {
      .icon[class*="chevron"] {
        transform: rotate(90deg);
      }
    }
  }

  .icon.attach {
    vertical-align: -2px;
    font-size: 16px;
  }

  .disable {
    opacity: .2;
    pointer-events: none;
  }

  /deep/ {
    .ob-tabs__panel {
      height: 46px;
      box-shadow: 0 0 2px rgba(0, 75, 200, 0.15),
      0 0 12px rgba(0, 75, 200, 0.04),
      0 4px 10px rgba(0, 75, 200, 0.06);
    }

    .preloader .loader {
      margin: 30px auto;
    }
  }
}
</style>
